
<template>

	<div class="flex justify-around sm:justify-center my-5" v-if="totalPages > 1 || showIfSinglePage">
		<button class="btn" :class="{ 'btn-disabled': !hasPrevious }" @click="previous()">&laquo; Prev</button>

		<button v-for="pageIndex in pageLinksToShow" :key="pageIndex" class="btn btn-sm hidden sm:inline" :class="{ 'btn-active': pageIndex === currentPage }" @click="goToPage( pageIndex )">
			{{ pageIndex + 1 }}
		</button>

		<button class="btn" :class="{ 'btn-disabled': !hasNext }" @click="next()">Next &raquo;</button>
	</div>

</template>

<script>

function range(start, end) {
	let length = end - start;
	return new Array(length).fill(1).map((_, i) => start + i);
}

/**
 * Component responsible for handling the pagination of a given list.
 * Requires currentPage and totalPages input properties, emits pageChanged events on user interactions.
 */
export default {
	props: {
		/**
		 * The index of the page we are currently looking at.
		 */
		currentPage: {
			type: Number,
			required: true
		},
		/**
		 * The amount of available pages.
		 */
		totalPages: {
			type: Number,
			required: true
		},
		/**
		 * If false and there is a single page available, hide navigation links.
		 */
		showIfSinglePage: {
			type: Boolean,
			default: false
		},
		/**
		 * How many page links to show in the pagination.
		 * Set to 0 for no explicit page navigation (only Prev and Next links available).
		 * Set to an odd number for best results.
		 */
		maxPageLinksToShow: {
			type: Number,
			default: 5
		}
	},
	emits: [
		'pageChanged'
	],
	computed: {
		hasNext() {
			return this.currentPage < this.totalPages - 1; // first page is page 0
		},
		hasPrevious() {
			return this.currentPage > 0;
		},
		pageLinksToShow() {

			// Ensure we have at least one page link to show and that the functionality is enabled.
			if ( this.totalPages === 0 && this.maxPageLinksToShow >= 1 ) 
				return [];

			// Try to keep a balanced number of pages, n/2 at the left of the current page and n/2 at the right.
			let pagesPerSide = ( this.maxPageLinksToShow - 1 ) / 2;
			let firstPage = this.currentPage - pagesPerSide;
			let lastPage = this.currentPage + pagesPerSide + 1;

			// Handle special cases where current page is either at the extreme left or extreme right of the interval.
			if ( firstPage < 0 ) {
				let overflow = -firstPage;
				lastPage = lastPage + overflow;
				firstPage = 0;
			}
			if ( lastPage > this.totalPages ) {
				let overflow = lastPage - this.totalPages;
				firstPage = Math.max( 0, firstPage - overflow );
				lastPage = this.totalPages;
			}

			// Create the array of page indexes.
			return range( firstPage, lastPage );
		}
	},
	methods: {
		goToPage( n ) {
			this.$emit( 'pageChanged', n );
		},
		next() {
			this.goToPage( this.currentPage + 1 );
		},
		previous() {
			this.goToPage( this.currentPage - 1 );
		}
	},
}
</script>
